/*
 * ΰDirichlet
 *
 */



#include<stdio.h>
#include<math.h>
#include<matrix.h>
#define G_DOUBLE
#include <glsc.h>
#define PI M_PI

main()
{
  int i,j,k,Kmax,NX,NY,skip;
  double tau,hx,hy,lambdax,lambday,lambdax2,lambday2,Tmax,dt;
  matrix u1,u2,u3;
  double f(),g();
  char message[80];

  printf("NX=\n");
  scanf("%d",&NX);
  printf("NY=\n");
  scanf("%d",&NY);
  printf("tau=\n");
  scanf("%lf",&tau);
  printf("dt=\n");
  scanf("%lf",&dt);

  u1 = new_matrix(NX+1, NY+1);
  u2 = new_matrix(NX+1, NY+1);
  u3 = new_matrix(NX+1, NY+1);

  hx=1.0/NX;
  hy=1.0/NY;
  printf("hx=%f\n",hx);
  printf("hy=%f\n",hy);
  lambdax=tau/hx;
  lambday=tau/hy;
  lambdax2=lambdax*lambdax;
  lambday2=lambday*lambday;
  printf("lambdax2=%f\n",lambdax*lambdax);
  printf("lambday2=%f\n",lambday*lambday);

  printf("tau=%f\n",tau);
  printf("Tmax=\n");
  scanf("%lf",&Tmax);

  skip=dt/tau+0.5;

  g_init("Meta6",250.0,160.0);
  g_device(G_BOTH);
  g_def_scale(0,0.0,1.0,0.0,1.0,30.0,70.0,100.0,72.0);
  g_def_scale(4,-1.0,1.0,-1.0,1.0,30.0,30.0,100.0,100.0);
  g_def_line(0,G_BLACK,0,G_LINE_SOLID);
  g_sel_scale(0);
  g_def_text(0, G_BLACK, G_FONT_TIMES_24);
  g_sel_text(0);


  Kmax=Tmax / tau + 0.1;
  printf("tau=%g, dt=%g, skip=%d, Tmax=%g, kmax=%d\n", tau, dt, skip, Tmax, Kmax);

  for(i=0;i<=NX;i++)
    for(j=0;j<=NY;j++)
      u1[i][j]=f(i*hx,j*hy);

  g_cls();
  g_hidden2(1.0,1.0,0.4,-1.0,1.0,5.0,25.0,20.0,20.0,20.0,
            150.0,100.0,u1,NX+1,NY+1,
            1,G_SIDE_NONE,2,1);
  for(i=1;i<=NX-1;i++)
    for(j=1;j<=NY-1;j++)
      u2[i][j]=(1.0-lambdax2-lambday2)*u1[i][j]
                +0.5*(lambdax2*(u1[i+1][j]+u1[i-1][j])
                 + lambday2*(u1[i][j+1]+u1[i][j-1]))+tau*g(i*hx,j*hy);
  for(j=0;j<=NY;j++)
    u2[0][j]=u2[NX][j]=0.0;
  for(i=0;i<=NX;i++)
    u2[i][0]=u2[i][NY]=0.0;

  for(k=1;k<=Kmax;k++){
    for(i=1;i<=NX-1;i++)
      for(j=1;j<=NY-1;j++)
        u3[i][j]=2*(1.0-lambdax2-lambday2)*u2[i][j]
                  +lambdax2*(u2[i+1][j]+u2[i-1][j])
                    +lambday2*(u2[i][j+1]+u2[i][j-1])-u1[i][j];
    for(j=0;j<=NY;j++)
      u3[0][j]=u3[NX][j]=0.0;
    for(i=0;i<=NX;i++)
      u3[NX][j]=u3[i][NY]=0.0;
    for(i=1;i<=NX;i++){
      for(j=1;j<=NY;j++){
        u1[i][j]=u2[i][j];
        u2[i][j]=u3[i][j];
      }
    }
    u1[0][0]=0.0;
    u1[NX][NY]=0.0;

    if (k%skip==0){
      g_cls();
      sprintf(message, "t=%g", k * tau);
      g_text(100.0, 20.0, message);
      g_hidden2(1.0,1.0,0.4,-1.0,1.0,5.0,25.0,20.0,20.0,20.0,
                150.0,100.0,u1,NX+1,NY+1,
                1,G_SIDE_NONE,2,1);
    }
  }
    g_sleep(-1.0);
    g_term();
    return 0;
}

  double f(x,y) 
  double x,y;
{
  return sin(PI*x)*sin(PI*y);
}

  double g(x,y)
  double x,y;
{
  return 0,0;
}
    
  
  








